#include <iostream>
#include <iomanip>
#include <string>
#include <vector>

using namespace std;

void MergeSort(vector<int> &A, int left, int right);
void Merge(vector<int> &A, int left, int mid, int right);

ostream& operator<<(ostream &sout, const vector<int> &A);

int main() {

	vector<int> N;
	N.push_back(1);      N.push_back(4);       N.push_back(32);
	N.push_back(5);      N.push_back(12);      N.push_back(28);
	N.push_back(6);      N.push_back(21);      N.push_back(54);
	N.push_back(8);      N.push_back(21);      N.push_back(76);
	N.push_back(9);      N.push_back(28);      N.push_back(29);
	N.push_back(30);

	cout << endl << "N: " << N << endl;

	MergeSort(N, 0, N.size()-1);

	cout << endl << "N: " << N << endl;

	return 0;
}

void Merge(vector<int> &A, int left, int mid, int right) {
	// create temporary container of merged sublists
	int bsize = right - left + 1;
	vector<int> B(bsize);

	// set up indices into lists and sublists
	int i = left;     // index to current element of the A left sublist
	int j = mid + 1;  // index to current element of the A right sublist
	int k = 0;        // index to where the next merge element belongs in B

	// first process the case where both sublists of A have elements to consider
	while ((i <= mid) && (j <= right)) { // both sublists lists still have elements to consider
		if (A[j] < A[i]) { // current element in right sublist is smaller
			// ************ copy A[j] to B[k] ************

			// ************ update k and j as we have merged another element ************

		}
		else { // current element in left sublist is smaller (or equal)
			// ************ copy A[i] to B[k] ************

			// ************ update k and i as we have merged another element ************

		}
	}

	// now process the remaining sublist that has elements to consider
	if (i <= mid) { // left sublist still has elements, right sublist does not
		while (i <= mid) { // merge another element
			// ************ copy A[i] to B[k] ************

			// ************ update k and i as we have merged another element ************
		}
	}
	else { // right sublist still has elements
		while (j <= right) { // merge another element
			// ************ Copy A[j] to B{k] ************

			//************ update k and j as we have merged another element ************
		}
	}

	// copy B element by element into A[left] ... A[right]
	for (int e = 0; e < B.size(); ++e) {
		// ************ copy the next element ************
	}
}


// MergeSort(): recursive sorting method
void MergeSort(vector<int> &A, int left, int right) {
	int size = right - left + 1;
	int mid = (left + right)/2;
	if (size > 2) { // at least one sublist has at least 2 elements
		MergeSort(A, left, mid);
		MergeSort(A, mid + 1, right);
	}
	if (size > 1) { // there are lists two merge
		Merge(A, left, mid, right);
	}
}


ostream& operator<<(ostream &sout, const vector<int> &A) {
	sout << "[ ";
	for (int i = 0; i < A.size(); ++i) {
		sout << A[i] << " ";
	}
	sout << "]";
	return sout;
}
